package com.ejie.ad74a.scheduler;

import java.util.Calendar;

import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.context.support.SpringBeanAutowiringSupport;

import com.ejie.ad74a.service.ArchivoExpedientesService;

/**
 * Gestión del proceso de archivo de expedientes
 * 
 * @author AGALLEGO
 *
 */
public class ArchivoExpedientesRespuestaJob implements Job {

	private static final Logger logger = LoggerFactory.getLogger(ArchivoExpedientesRespuestaJob.class);

	@Autowired
	ArchivoExpedientesService archivoExpedientesService;

	/**
	 * archivo de expedientes
	 */
	@Override
	public void execute(JobExecutionContext jobexecutioncontext) throws JobExecutionException {
		// ** PROCESO DE RESPUESTA ** //
		ArchivoExpedientesRespuestaJob.logger.info("--Proceso de respuesta a archivo de expedientes- Fecha: "
				+ Calendar.getInstance().getTime().toString() + " --INICIO--");

		// ** Soporte a Autowiring ** //
		SpringBeanAutowiringSupport.processInjectionBasedOnCurrentContext(this);
		try {
			ArchivoExpedientesRespuestaJob.logger
					.info("--Proceso de archivo de expedientes- Proceso de respuesta a archivo de expedientes... ");

			this.archivoExpedientesService.procesarRespuesta();

		} catch (Throwable t) {
			ArchivoExpedientesRespuestaJob.logger
					.error("--Proceso de respuesta a archivo de expedientes- ERROR: " + t.getStackTrace());
		}

		ArchivoExpedientesRespuestaJob.logger.info("--Proceso de respuesta  archivo de expedientes- Fecha: "
				+ Calendar.getInstance().getTime().toString() + " --FIN--");

	}

}
